ChkCPU:
;Zakadam, e w tym miejscu procesor pracuje w trybie uytkownika (User mode).
;Kady procesor 680x0 pracuje w tym trybie, po uruchomieniu programu na Workbenchu.
;Program sprawdza i wywietla model procesora 680x0, zainstalowanego w Amidze.
;Dziaa w systemie 1.2 lub nowszym i mona go uruchomi przez ikon lub z CLI.

 moveq    #$30,D1    ;procesor 68000
 move.l   4.w,A6     ;adres bazowy biblioteki Exec
 btst     #0,297(A6) ;warto bitu okrela procesor: 0=68000, 1=68010 lub nowszy (bit ten wchodzi
                     ;w skad flag AttnFlags, wypenianych przez bibliotek Exec podczas startu Amigi).
 beq.s    ChkCPU0    ;procesor 68000

;W tym miejscu procesor to 68010 lub nowszy

 lea      ChkCPU1(pc),A5 ;adres procedury, ktra zostanie wykonana w trybie nadzorcy
 jsr      -30(A6)    ;przecza procesor w tryb nadzorcy i wykonuje procedur (funkcja Exec:Supervisor)
ChkCPU0:
 lea      ChkCPU4(pc),A0
 move.l   A0,D2      ;adres danych do wywietlenia w CLI
 move.b   D1,8(A0)   ;warto okrela model procesora: $30-$36=68000-68060
 lea      ChkCPU5(pc),A1 ;nazwa biblioteki DOS
 jsr      -408(A6)   ;otwiera bibliotek DOS (funkcja Exec:OldOpenLibrary)
 move.l   D0,A6      ;adres bazowy biblioteki DOS
 jsr      -60(A6)    ;zwraca uchwyt okna CLI do wywietlania danych. Jeli nie ma
                     ;takiego okna, to jest ono otwierane (funkcja DOS:Output).
 move.l   D0,D1      ;uchwyt okna CLI
 moveq    #11,D3     ;liczba bajtw do wywietlenia w CLI
 jsr      -48(A6)    ;wywietla dane w CLI (funkcja DOS:Write)
 move.l   A6,A1      ;adres bazowy biblioteki DOS
 move.l   4.w,A6     ;adres bazowy biblioteki Exec
 jsr      -414(A6)   ;zamyka bibliotek DOS (funkcja Exec:CloseLibrary)
 rts

ChkCPU1:             ;procedura wykonywana przez funkcj Exec:Supervisor
 dc.l     $4E7A3801  ;MOVEC VBR,D3 - instrukcja przenosi warto rejestru VBR do rejestru D3.
                     ;Jest obsugiwana przez procesory 68010/20/30/40/60.
 moveq    #$10,D2
 move.l   D2,A1
 add.l    D3,A1
 move.l   (A1),D2    ;wektor wyjtku nr 4 (Illegal Instruction), ktry wystpi
                     ;gdy procesor natrafi na kod nieobsugiwanej instrukcji.
 lea      ChkCPU3(pc),A0
 move.l   A0,(A1)    ;zmiana wektora wyjtku nr 4
 move.l   D3,A2
 moveq    #$2C,D3
 add.l    D3,A2
 move.l   (A2),D3    ;wektor wyjtku nr 11 (Line 1111 Emulator), ktry wystpi gdy procesor
                     ;natrafi na kod nieobsugiwanej instrukcji, rozpoczynajcy si sowem $Fnnn.
 lea      ChkCPU2(pc),A0
 move.l   A0,(A2)    ;zmiana wektora wyjtku nr 11
 move.l   A7,A3      ;zapamitanie wskanika stosu (A7=SSP)
 moveq    #$31,D1    ;procesor 68010
 dc.l     $4E7A1002  ;MOVEC CACR,D1 - instrukcja obsugiwana przez 68020/30/40/60
 moveq    #$32,D1    ;procesor 68020/68030
 dc.l     $4E7A1004  ;MOVEC ITT0,D1 - instrukcja obsugiwana przez 68040/60.
                     ;Przenosi warto rejestru ITT0 (68040, 68LC040, 68060,
                     ;68EC060, 68LC060)/IACR0 (68EC040) do rejestru D1.
 moveq    #$34,D1    ;procesor 68040
 dc.l     $4E7A1808  ;MOVEC PCR,D1 - instrukcja obsugiwana przez 68060
 moveq    #$36,D1    ;procesor 68060
ChkCPU2:             ;kod obsugi wyjtku nr 11 (tylko dla 68020)
 move.l   D2,(A1)    ;przywrcenie wektora wyjtku nr 4
 move.l   D3,(A2)    ;przywrcenie wektora wyjtku nr 11
 move.l   A3,A7      ;przywrcenie wskanika stosu (A7=SSP)
 rte                 ;powrt z funkcji Exec:Supervisor

ChkCPU3:             ;kod obsugi wyjtku nr 4
 cmp.b    #$32,D1
 bne.s    ChkCPU2

;Rozpoznawanie procesora 68020/68030

 dc.w     $F02F,$6200,$FFFE ;PMOVE.W PSR,-2(A7) - instrukcja odkada na stos (A7=SSP)
                            ;warto rejestru MMUSR (68030)/ACUSR (68EC030).
                            ;Na procesorze 68020 powoduje wystpienie wyjtku nr 11.
 moveq    #$33,D1    ;procesor 68030
 bra.s    ChkCPU2

ChkCPU4:
 dc.b     "CPU: 680x0",10
ChkCPU5:
 dc.b     "dos.library",0

;Rozmiar: 168 B, linii kodu: 52